# this script gets called by config_sessions

PLUGIN_NAME="egk_scm"
PLUGIN_MENUITEM_NAME="SUM_EGK"
PLUGIN_MENUITEM_EXEC="rdesktop"
PLUGIN_MENUITEM_PARAM='-r scard:\"eHealth200 Terminal 00 00\"=\"SCM Microsystems Inc. Terminal0-Patient slot 0\",\"eHealth200 Terminal 00 01\"=\"SCM Microsystems Inc. Terminal0-Doctor slot 0\"'
PLUGIN_MENUITEM_WORKDIR=""
PLUGIN_MENUITEM_ICON=""

PLUGIN_AUTOSTART=0
PLUGIN_PACKAGES="libusb libusb-compat pcsc-lite pcsc-plugin-ehealth200"
# uses rdesktop plugin config
PLUGIN_CONFIG="/etc/alxconfig-ng/plugin-rdesktop.conf"

# include alx functions
source /etc/alxconfig-ng/config.rc
source /etc/alxconfig-ng/serial
source ${ALX_FUNCTIONS}/common
source ${ALX_FUNCTIONS}/mysqlfunctions

install_plugin()
{
	local i
	for i in ${PLUGIN_PACKAGES}
	do
		if [[ -z $(magequery -n ${i}) ]]
		then
			MAGE_BOOTSTRAP=true mage install ${i}
			mage clean
		fi
	done
}

setup_plugin()
{
	return 0
}

# create desktop buttons
create_menuitem()
{
	if [ -f ${PLUGIN_CONFIG} ]
	then
		source ${PLUGIN_CONFIG}

		# use session name from rdesktop if available
		if [[ ! -z ${PLUGIN_CONFIG_SESSION_NAME} ]]
		then
			PLUGIN_MENUITEM_NAME="${PLUGIN_CONFIG_SESSION_NAME}"
		fi
	else
		# rdesktop not configured, disable plugin
		PLUGIN_CONFIG_PARAM=""
		PLUGIN_CONFIG_SERVER=""
		PLUGIN_MENUITEM_NAME=""
		PLUGIN_MENUITEM_EXEC=""
		PLUGIN_MENUITEM_PARAM=""
		PLUGIN_MENUITEM_WORKDIR=""
		PLUGIN_MENUITEM_ICON=""
	fi

	# don't touch these echo, define variables above
	echo "PLUGIN_MENUITEM_NAME=\"${PLUGIN_MENUITEM_NAME}\""
	echo "PLUGIN_MENUITEM_EXEC=\"${PLUGIN_MENUITEM_EXEC}\""
	echo "PLUGIN_MENUITEM_PARAM=\"${PLUGIN_CONFIG_PARAM} ${PLUGIN_MENUITEM_PARAM} ${PLUGIN_CONFIG_SERVER}\""
	echo "PLUGIN_MENUITEM_WORKDIR=\"${PLUGIN_MENUITEM_WORKDIR}\""
	echo "PLUGIN_MENUITEM_ICON=\"${PLUGIN_MENUITEM_ICON}\""
}

autostart_plugin()
{
	# only run autostart if rdesktop was configured
	if [ -f ${PLUGIN_CONFIG} ]
	then
		source ${PLUGIN_CONFIG}
		evaluate_table plugin_egk_scm

		# use session name from rdesktop if available
		if [[ ! -z ${PLUGIN_CONFIG_SESSION_NAME} ]]
		then
			PLUGIN_MENUITEM_NAME="${PLUGIN_CONFIG_SESSION_NAME}"
		fi
	fi
	# sanitize variables
	[[ -z ${plugin_egk_scm_autostart} ]] && plugin_egk_scm_autostart=0

	echo "PLUGIN_AUTOSTART=\"${plugin_egk_scm_autostart}\""
	echo "PLUGIN_MENUITEM_NAME=\"${PLUGIN_MENUITEM_NAME}\""
}

uninstall_plugin()
{
	local i
	for i in ${PLUGIN_PACKAGES}
	do
		if [[ -n $(magequery -n ${i}) ]]
		then
			MAGE_BOOTSTRAP=true mage uninstall ${i}
			mage clean
		fi
	done

	mage clean
}

case $1 in
	install) install_plugin ;;
	setup) setup_plugin ;;
	menuitem) create_menuitem ;;
	autostart) autostart_plugin ;;
	uninstall) uninstall_plugin ;;
	*) echo "PLUGIN '${PLUGIN_NAME}': unkown operation '$1'" ;;
esac
